using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace SDGCandy
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainBox : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label lblMyJar;
		private System.Windows.Forms.Label lblYourJar;
		private System.Windows.Forms.Label lblMyJarCount;
		private Sdgt.SdgManager sdgManager1;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.PictureBox MyCandyJar;
		private System.Windows.Forms.PictureBox YourCandyJar;
		private System.Windows.Forms.Label lblYourJarCount;

		// variables for candies
		private int yourCount;
		private int myCount;
		
		private int iCandyCount = 18;
		private int jCandyCount = 11;
				
		private int colorCount = 7;
		private System.Windows.Forms.Label lblWin;
		private System.Windows.Forms.Label lblGameOver;	
		
		private SDGCandy.Candy [,] candies = new SDGCandy.Candy[18,11];

		private bool gameOver = false;

		public MainBox()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			//Set mice features
			Cursor[] sdgCursors = {Cursors.Arrow, Cursors.Hand};

			String[] sdgText = {"Me", "You"};
			Color[] sdgBrush = {Color.HotPink, Color.RoyalBlue};
			
			for (int i=0; i < sdgManager1.Mice.Count && i < 2; ++i)

			{

				sdgManager1.Mice[i].Cursor = sdgCursors[i];
				sdgManager1.Mice[i].Text = sdgText[i];
				sdgManager1.Mice[i].TextBrush = new SolidBrush(sdgBrush[i]);
				
			}

			// Set jar counts
			myCount = 0;
			yourCount = 0;
			this.lblMyJarCount.Text = myCount.ToString();
			this.lblYourJarCount.Text = yourCount.ToString();

			this.lblGameOver.Visible = false;
			this.lblGameOver.BackColor = Color.LightGray;
			this.lblGameOver.Text = "";
			this.lblWin.Text= "";



			//Create candies and set features
			System.Drawing.Point locPoint = new Point (0,0);
			System.Random rand = new Random();
			Color[] candyColors = {Color.HotPink, Color.RoyalBlue, Color.Yellow, Color.Green, Color.Red, Color.Chocolate, Color.Purple};	
			
			for (int j = 0; j< jCandyCount; j++)
			{

				for (int i = 0 ; i < iCandyCount; i++)
				{
					this.candies[i,j]= new SDGCandy.Candy();
					this.candies[i,j].Location = locPoint;
					int randNum = rand.Next(colorCount);
					this.candies[i,j].Color = candyColors[randNum];
					//this.candies[i,j].SdgMouseDown += new Sdgt.SdgMouseEventHandler(MainBox_SdgMouseDown);
					this.Controls.Add(this.candies[i,j]);
					//this.panel1.Controls.Add(this.candies[i,j]);
					locPoint.X = locPoint.X + 40;
				}
				locPoint.X = 0;
				locPoint.Y = locPoint.Y + 40;
			}


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainBox));
			this.panel2 = new System.Windows.Forms.Panel();
			this.lblWin = new System.Windows.Forms.Label();
			this.lblYourJarCount = new System.Windows.Forms.Label();
			this.lblMyJarCount = new System.Windows.Forms.Label();
			this.lblYourJar = new System.Windows.Forms.Label();
			this.lblMyJar = new System.Windows.Forms.Label();
			this.YourCandyJar = new System.Windows.Forms.PictureBox();
			this.MyCandyJar = new System.Windows.Forms.PictureBox();
			this.sdgManager1 = new Sdgt.SdgManager(this.components);
			this.lblGameOver = new System.Windows.Forms.Label();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.Color.White;
			this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel2.Controls.Add(this.lblWin);
			this.panel2.Controls.Add(this.lblYourJarCount);
			this.panel2.Controls.Add(this.lblMyJarCount);
			this.panel2.Controls.Add(this.lblYourJar);
			this.panel2.Controls.Add(this.lblMyJar);
			this.panel2.Controls.Add(this.YourCandyJar);
			this.panel2.Controls.Add(this.MyCandyJar);
			this.panel2.Location = new System.Drawing.Point(0, 448);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(725, 256);
			this.panel2.TabIndex = 1;
			// 
			// lblWin
			// 
			this.lblWin.Font = new System.Drawing.Font("Microsoft Sans Serif", 20.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblWin.Location = new System.Drawing.Point(280, 56);
			this.lblWin.Name = "lblWin";
			this.lblWin.Size = new System.Drawing.Size(144, 48);
			this.lblWin.TabIndex = 6;
			this.lblWin.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblYourJarCount
			// 
			this.lblYourJarCount.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblYourJarCount.Location = new System.Drawing.Point(496, 192);
			this.lblYourJarCount.Name = "lblYourJarCount";
			this.lblYourJarCount.Size = new System.Drawing.Size(24, 23);
			this.lblYourJarCount.TabIndex = 5;
			this.lblYourJarCount.Text = "0";
			this.lblYourJarCount.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblMyJarCount
			// 
			this.lblMyJarCount.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMyJarCount.Location = new System.Drawing.Point(176, 192);
			this.lblMyJarCount.Name = "lblMyJarCount";
			this.lblMyJarCount.Size = new System.Drawing.Size(26, 23);
			this.lblMyJarCount.TabIndex = 4;
			this.lblMyJarCount.Text = "0";
			this.lblMyJarCount.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblYourJar
			// 
			this.lblYourJar.BackColor = System.Drawing.Color.White;
			this.lblYourJar.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblYourJar.Location = new System.Drawing.Point(456, 168);
			this.lblYourJar.Name = "lblYourJar";
			this.lblYourJar.TabIndex = 3;
			this.lblYourJar.Text = "Your Candy Jar";
			this.lblYourJar.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblMyJar
			// 
			this.lblMyJar.BackColor = System.Drawing.Color.White;
			this.lblMyJar.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMyJar.Location = new System.Drawing.Point(144, 168);
			this.lblMyJar.Name = "lblMyJar";
			this.lblMyJar.TabIndex = 2;
			this.lblMyJar.Text = "My Candy Jar";
			this.lblMyJar.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// YourCandyJar
			// 
			this.YourCandyJar.Image = ((System.Drawing.Image)(resources.GetObject("YourCandyJar.Image")));
			this.YourCandyJar.Location = new System.Drawing.Point(456, 24);
			this.YourCandyJar.Name = "YourCandyJar";
			this.YourCandyJar.Size = new System.Drawing.Size(104, 144);
			this.YourCandyJar.TabIndex = 1;
			this.YourCandyJar.TabStop = false;
			// 
			// MyCandyJar
			// 
			this.MyCandyJar.Image = ((System.Drawing.Image)(resources.GetObject("MyCandyJar.Image")));
			this.MyCandyJar.Location = new System.Drawing.Point(144, 24);
			this.MyCandyJar.Name = "MyCandyJar";
			this.MyCandyJar.Size = new System.Drawing.Size(104, 144);
			this.MyCandyJar.TabIndex = 0;
			this.MyCandyJar.TabStop = false;
			// 
			// sdgManager1
			// 
			this.sdgManager1.EmulateSystemMouseMode = Sdgt.EmulateSystemMouseModes.Park;
			this.sdgManager1.Keyboards = null;
			this.sdgManager1.Mice = null;
			this.sdgManager1.MouseToFollow = 0;
			this.sdgManager1.ParkSystemMouseLocation = new System.Drawing.Point(350, 350);
			this.sdgManager1.RelativeTo = this;
			this.sdgManager1.MouseDown += new Sdgt.SdgMouseEventHandler(this.MainBox_SdgMouseDown);
			// 
			// lblGameOver
			// 
			this.lblGameOver.Font = new System.Drawing.Font("Microsoft Sans Serif", 48F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblGameOver.Location = new System.Drawing.Point(152, 88);
			this.lblGameOver.Name = "lblGameOver";
			this.lblGameOver.Size = new System.Drawing.Size(392, 240);
			this.lblGameOver.TabIndex = 2;
			this.lblGameOver.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// MainBox
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.LightGray;
			this.ClientSize = new System.Drawing.Size(725, 686);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.lblGameOver);
			this.Name = "MainBox";
			this.Text = "Candy Jar";
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainBox());
		}
		
		//SDG Mouse Event on hitting a candy
		private void MainBox_SdgMouseDown(object sender, Sdgt.SdgMouseEventArgs e)
		{
			if (this.gameOver == true)
			{
				//do nothing
			}
			else
			{
			
				if (sender is SDGCandy.Candy)
				{
					SDGCandy.Candy smartie = (SDGCandy.Candy)sender;

					//Points for me
					if (e.ID < 1)
					{
						if (smartie.Color == Color.HotPink)
						{
							this.AddMyCount();
						}
						else if (smartie.Color == Color.RoyalBlue)
						{
							this.SubYourCount();
						}
						else if (smartie.Color == Color.LightGray)
						{
							//do nothing
						}
						else 
						{
							this.SubMyCount();
						}
					}

					//Points for you
					if (e.ID > 0 )
					{
						if (smartie.Color == Color.RoyalBlue)
						{
							this.AddYourCount();
						}
						else if (smartie.Color == Color.HotPink)
						{
							this.SubMyCount();
						}
						else if (smartie.Color == Color.LightGray)
						{
							//do nothing
						}
						else 
						{
							this.SubYourCount();
						}
					}
					smartie.Color = Color.LightGray;
								
					System.Diagnostics.Debug.WriteLine("candy clicked");
				}
			}
		}

		// Actions when my count is increased
		public void AddMyCount()
		{
			this.myCount++;
			this.lblMyJarCount.Text = myCount.ToString();
			
			if (this.myCount >= 5)
			{
				this.MyCandyJar.Image = Image.FromFile("Images/HalfJar.jpg");
			}
			if (this.myCount == 10)
			{
				this.MyCandyJar.Image = Image.FromFile("Images/FullJar.jpg");
				this.GameOver(0);
			}
		}

		// Actions when my count is decreased
		public void SubMyCount()
		{
			if (this.myCount != 0)
			{
				this.myCount--;
				this.lblMyJarCount.Text = myCount.ToString();
				if (this.myCount < 5)
				{
					this.MyCandyJar.Image = Image.FromFile("Images/HalfJar.jpg");
				}
				if (this.myCount == 0)
				{
					this.MyCandyJar.Image = Image.FromFile("Images/EmptyJar.jpg");
				}
			}
		}

		// Actions when your count is increased
		public void AddYourCount()
		{
			this.yourCount++;
			this.lblYourJarCount.Text = yourCount.ToString();
			if (this.yourCount >= 5)
			{
				this.YourCandyJar.Image = Image.FromFile("Images/HalfJar.jpg");
			}
			if (this.yourCount == 10)
			{
				this.YourCandyJar.Image = Image.FromFile("Images/FullJar.jpg");
				this.GameOver(1);
			}
		}

		// Actions when my count is decreased
		public void SubYourCount()
		{
			if (this.yourCount != 0)
			{
				this.yourCount--;
				this.lblYourJarCount.Text = yourCount.ToString();
				if (this.yourCount < 5)
				{
					this.YourCandyJar.Image = Image.FromFile("Images/HalfJar.jpg");
				}
				if (this.yourCount == 0)
				{
					this.YourCandyJar.Image = Image.FromFile("Images/EmptyJar.jpg");
				}

			}
		}


		// Do game over procedures
		public void GameOver(int winner)
		{
			gameOver = true;
			
			for (int j = 0; j< jCandyCount; j++)
			{
				for (int i = 0 ; i < iCandyCount; i++)
				{
					this.candies[i,j].Color = Color.Gray;
					this.candies[i,j].Enabled = false;
				}				
			}
			this.lblGameOver.BackColor = Color.White;
			this.lblGameOver.Text = "Game Over!";
			this.lblGameOver.Visible = true;
			this.lblGameOver.BringToFront();

			if (winner == 0)
			{
				this.lblWin.Text= " I win! ";
			}
			else if (winner == 1)
			{
				this.lblWin.Text = " You win! ";
			}
		}

		


		
	}
}
